Story # 54261 (Resolved): As an Extension-Developer I want to use FAL assets in my custom development

Status: Resolved Priority: Must have
Author: Markus Klein Category: File Abstraction Layer (FAL)
Created: 2013-11-19 Assigned To: Steffen Ritter
Updated: 2014-02-18 Due date: 2013-12-31
TYPO3 Version: 6.2
PHP Version:
Complexity: hard
Sprint Focus:
Subject: MetaData updated during runtime is not updated in the FileObject Instance
Description

If using the image viewhelper, which now uses FAL API directly, the returned File object does not have a width and height.

Example:
<f:image src="../some/what/ever/path/to/file.png" alt="This will have empty width and height attributes"/>
Stacktrace:
    -  ImageViewHelper:103 $image = $this->imageService->getImage($src, $image, $treatIdAsReference);
    -  ...
    -  ImageService:139 $image = $this->resourceFactory->retrieveFileOrFolderObject($src);
    -  ...
    -  ResourceFactory:389 $fileObject = $this->getIndexer($storage)->createIndexEntry($fileIdentifier);
    -  Indexer:70 $this->extractRequiredMetaData($fileObject);
    -  Indexer:218 $this->getMetaDataRepository()->update($fileObject->getUid(), $metaData);

The $metaData does properly contain width/height and things get written to DB here, but the actual $fileObject, which will be returned
by retrieveFileOrFolderObject() afterwards is never updated with the additional meta data.

This can be tested with the Language module, if you revert https://review.typo3.org/25516 locally. The extension icons have empty(!)
width and height attributes.

Associated revisions
Revision d4b2d215 - 2014-02-18 19:51 - Steffen Ritter

[BUGFIX] Indexer does not update the FileObjects

If the Indexer updates metadata during runtimer (after a file object)
has been created, the file object itself is not updated.

This leads to possible errors with image rendering, if files are to be
shown which have not been indexed before.

Releases: 6.2
Resolves: #53772
Change-Id: I70be5ebefe1e00e903694a576847fa8fba167461
Reviewed-on: https://review.typo3.org/27690
Reviewed-by: Markus Klein
Tested-by: Markus Klein
Reviewed-by: Wouter Wolters
Tested-by: Wouter Wolters

History
#1 - 2013-11-30 16:06 - Steffen Ritter
- Target version changed from next-patchlevel to 6.2.0

#2 - 2013-11-30 16:10 - Steffen Ritter
- Subject changed from FAL does not populate meta data into File objects to MetaData updated during runtime is not updated in the FileObject 
Instance
- Status changed from Accepted to Needs Feedback

The $metaData does properly contain width/height and things get written to DB here, but the actual $fileObject, which will be returned by
retrieveFileOrFolderObject() afterwards is never updated with the additional meta data.

#3 - 2013-11-30 16:11 - Steffen Ritter
- Status changed from Needs Feedback to Accepted

#4 - 2013-12-06 11:42 - Steffen Ritter
- Due date set to 2013-12-31
- Estimated time set to 3.50

#5 - 2013-12-07 15:22 - Steffen Ritter
- Parent task set to #54261

#6 - 2014-02-18 14:24 - Steffen Ritter
- % Done changed from 0 to 70

#7 - 2014-02-18 20:30 - Steffen Ritter
- Status changed from Accepted to Resolved
- % Done changed from 70 to 100

Applied in changeset commit:d4b2d2158aab71ed691e16085d1fa0a52d8290a2.
